diff -r 1e55e1aa8b7f sys/netinet/tcp_syncache.c
--- a/sys/netinet/tcp_syncache.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_syncache.c	Fri Jul 11 13:32:06 2014 +1000
@@ -41,6 +41,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/endian.h>
 #include <sys/sysctl.h>
 #include <sys/limits.h>
 #include <sys/lock.h>
@@ -53,6 +54,7 @@
 #include <sys/socketvar.h>
 #include <sys/syslog.h>
 #include <sys/ucred.h>
+#include <sys/queue.h>
 
 #include <sys/md5.h>
 #include <crypto/siphash/siphash.h>
@@ -78,11 +80,15 @@
 #include <netinet6/ip6_var.h>
 #include <netinet6/in6_pcb.h>
 #endif
+
+
 #include <netinet/tcp.h>
 #include <netinet/tcp_fsm.h>
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_var.h>
 #include <netinet/tcp_syncache.h>
 #ifdef INET6
 #include <netinet6/tcp6_var.h>
@@ -143,6 +149,12 @@
 		    struct syncache *sc, struct tcphdr *th, struct tcpopt *to,
 		    struct socket *lso);
 #endif
+static struct	 socket *syncache_socket_subflow(struct syncache *, struct socket *,
+		    struct mbuf *m, struct sockaddr_in *nam);
+static inline struct inpcb*
+		inp_lookup(struct in_addr *faddr, struct in_addr *laddr, uint16_t fport,
+			uint16_t lport);
+
 
 /*
  * Transmit the SYN,ACK fewer times than TCP_MAXRXTSHIFT specifies.
@@ -659,7 +671,9 @@
 {
 	struct inpcb *inp = NULL;
 	struct socket *so;
+	struct mpcb *mp;
 	struct tcpcb *tp;
+
 	int error;
 	char *s;
 
@@ -835,9 +849,56 @@
 #endif /* INET */
 	INP_HASH_WUNLOCK(&V_tcbinfo);
 	tp = intotcpcb(inp);
+
+	/* create the multipath control block */
+	mp = mp_newmpcb(inp);
+	mp->master_tcpcb = tp;
+
+	/* put the master flow first in the list of subflows */
+	SLIST_INSERT_HEAD(&mp->tp_list, mp->master_tcpcb, next_subflow);
+
+	mp->subflow_cnt = 1;
+	tp->t_mpcb = mp;
+
+	/* XXXNJW: a workaround until path manager is implemented. Prevents a
+	 * host that is a passive opener from issuing MP_JOINs to addresses
+	 * added via ADD_ADDR if the passive host has more than one interface (i.e.
+	 * it will be send ADD_ADDRs of it's own). This means that the extra
+	 * mp_addresses are used in PASSIVE OPEN mode only. Prevents opening
+	 * multiple subflows between the same two pairs of addresses (and some
+	 * races with the async task handlers). */
+	mp->passive_open = 1;
+	mp_debug(MPSESSION, 5, 0, "%s: passive open: %d,\n", __func__,
+	     mp->passive_open);
+
+	/* should have a sysctl to check if we want to enable */
+
 	tcp_state_change(tp, TCPS_SYN_RECEIVED);
+
 	tp->iss = sc->sc_iss;
 	tp->irs = sc->sc_irs;
+
+	if (sc->is_master_subflow) {
+		tp->infinite_map = 1;
+		tp->t_mpcb->ds_map_max = tp->t_mpcb->ds_map_min = tp->t_mpcb->ds_snd_una = sc->sc_iss + 1;
+		tp->t_mpcb->ds_rcv_nxt = sc->sc_irs + 1;
+	}
+
+	/*
+	 * Only need to check for sent_capable as on the passive side if
+	 * this is set then mpc is also set.
+	 */
+	if (sc->sent_capable) {
+		tp->t_mpcb->csum_enabled = sc->csum_enabled;
+		tp->mpc = sc->mpc;
+		tp->sent_capable = 1;
+
+		if (sc->is_master_subflow) {
+			mp_process_local_key(tp->t_mpcb, sc->sc_local_key);
+			mp_process_remote_key(tp->t_mpcb, sc->sc_remote_key);
+		}
+	}
+
 	tcp_rcvseqinit(tp);
 	tcp_sendseqinit(tp);
 	tp->snd_wl1 = sc->sc_irs;
@@ -848,6 +909,8 @@
 	tp->rcv_adv += tp->rcv_wnd;
 	tp->last_ack_sent = tp->rcv_nxt;
 
+	tp->t_mpcb->ds_rcv_wnd = (uint32_t) tp->rcv_wnd;
+
 	tp->t_flags = sototcpcb(lso)->t_flags & (TF_NOPUSH|TF_NODELAY);
 	if (sc->sc_flags & SCF_NOOPT)
 		tp->t_flags |= TF_NOOPT;
@@ -924,6 +987,149 @@
 	return (NULL);
 }
 
+
+/*
+ * return the master socket for this subflow
+ */
+static struct socket *
+syncache_socket_subflow(struct syncache *sc, struct socket *lso,
+    struct mbuf *m, struct sockaddr_in *nam)
+{
+	struct inpcb *inp;
+	struct mpcb *mp;
+	struct socket *so;
+	struct tcpcb *tp;
+//	int error = 0;
+	int token;
+
+	token = sc->sc_mp_token;
+
+	/* Find the mp for the subflow connection token provided */
+	INP_INFO_LOCK_ASSERT(&V_tcbinfo);
+	LIST_FOREACH(inp, &V_tcb, inp_list) {
+		INP_WLOCK(inp);
+		/* Important to skip tcptw structs. */
+		if (!(inp->inp_flags & INP_TIMEWAIT) &&
+			(tp = intotcpcb(inp)) != NULL) {
+			if (tp->mp_active) {
+				if (inp == tp->t_mpcb->master_inpcb
+					&& tp->t_mpcb->local_token == token) {
+					break;
+				}
+			}
+		}
+		INP_WUNLOCK(inp);
+	}
+	KASSERT(inp != NULL,("%s: inp is null\n", __func__));
+
+	/* inp is the master inp at this point */
+	mp = intotcpcb(inp)->t_mpcb;
+	so = inp->inp_socket;
+
+	/* unlocking the master inp */
+	INP_WUNLOCK(inp);
+
+	/* Find the inp for this subflow */
+	inp = in_pcblookup_mbuf(&V_tcbinfo, nam->sin_addr,
+		nam->sin_port, sc->sc_inc.inc_laddr, sc->sc_inc.inc_lport,
+		INPLOOKUP_WILDCARD | INPLOOKUP_WLOCKPCB,
+		m->m_pkthdr.rcvif, m);
+
+	KASSERT(inp != NULL,("%s: inp is null (not found in lookup\n", __func__));						// XXXNJW to remove
+
+	inp->inp_inc.inc_flags = sc->sc_inc.inc_flags;
+	inp->inp_laddr = sc->sc_inc.inc_laddr;
+	inp->inp_lport = sc->sc_inc.inc_lport;
+
+	inp->inp_faddr = nam->sin_addr; //sc->sc_inc.inc_faddr;
+	inp->inp_fport = nam->sin_port;
+
+//	INP_HASH_WLOCK(&V_tcbinfo);
+//	in_pcbinshash(inp);
+//	INP_HASH_WUNLOCK(&V_tcbinfo);
+
+	tp = intotcpcb(inp);
+
+	tp->iss = sc->sc_iss;
+	tp->irs = sc->sc_irs;
+
+	tcp_rcvseqinit(tp);
+	tcp_sendseqinit(tp);
+	tp->snd_wl1 = sc->sc_irs;
+	tp->snd_max = tp->iss + 1;
+	tp->snd_nxt = tp->iss + 1;
+	tp->rcv_up = sc->sc_irs + 1;
+	tp->rcv_wnd = sc->sc_wnd;
+	tp->rcv_adv += tp->rcv_wnd;
+	tp->last_ack_sent = tp->rcv_nxt;
+
+	/* the HMACs generated during MP_JOIN handshake */
+	bcopy(sc->sc_hmac_local, tp->hmac_local, 20);
+	bcopy(sc->sc_hmac_remote, tp->hmac_remote, 20);
+
+	tp->t_flags = sototcpcb(lso)->t_flags & (TF_NOPUSH|TF_NODELAY);
+	if (sc->sc_flags & SCF_NOOPT)
+		tp->t_flags |= TF_NOOPT;
+	else {
+		if (sc->sc_flags & SCF_WINSCALE) {
+			tp->t_flags |= TF_REQ_SCALE|TF_RCVD_SCALE;
+			tp->snd_scale = sc->sc_requested_s_scale;
+			tp->request_r_scale = sc->sc_requested_r_scale;
+		}
+		if (sc->sc_flags & SCF_TIMESTAMP) {
+			tp->t_flags |= TF_REQ_TSTMP|TF_RCVD_TSTMP;
+			tp->ts_recent = sc->sc_tsreflect;
+			tp->ts_recent_age = tcp_ts_getticks();
+			tp->ts_offset = sc->sc_tsoff;
+		}
+#ifdef TCP_SIGNATURE
+		if (sc->sc_flags & SCF_SIGNATURE)
+			tp->t_flags |= TF_SIGNATURE;
+#endif
+		if (sc->sc_flags & SCF_SACK)
+			tp->t_flags |= TF_SACK_PERMIT;
+	}
+
+	if (sc->sc_flags & SCF_ECN)
+		tp->t_flags |= TF_ECN_PERMIT;
+
+	tp->mp_active = 1;
+	tp->mpc = 1;
+	tp->t_state = TCPS_SYN_RECEIVED;
+
+	/*
+	 * Set up MSS and get cached values from tcp_hostcache.
+	 * This might overwrite some of the defaults we just set.
+	 */
+	tcp_mss(tp, sc->sc_peer_mss);
+
+	/*
+	 * If the SYN,ACK was retransmitted, reset cwnd to 1 segment.
+	 * NB: sc_rxmits counts all SYN,ACK transmits, not just retransmits.
+	 */
+	if (sc->sc_rxmits > 1)
+		tp->snd_cwnd = tp->t_maxseg;
+
+	/*
+	 * Copy and activate timers.
+	 */
+	tp->t_keepinit = sototcpcb(lso)->t_keepinit;
+	tp->t_keepidle = sototcpcb(lso)->t_keepidle;
+	tp->t_keepintvl = sototcpcb(lso)->t_keepintvl;
+	tp->t_keepcnt = sototcpcb(lso)->t_keepcnt;
+	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
+
+	INP_WUNLOCK(inp);
+
+	TCPSTAT_INC(tcps_accepts);
+
+	return (so);
+
+//	SOCK_UNLOCK(so);
+//	INP_WUNLOCK(inp);
+//	return (NULL);
+}
+
 /*
  * This function gets called when we receive an ACK for a
  * socket in the LISTEN state.  We look up the connection
@@ -1070,7 +1276,154 @@
 	else
 		TCPSTAT_INC(tcps_sc_completed);
 
-/* how do we find the inp for the new socket? */
+	if (sc != &scs)
+		syncache_free(sc);
+	return (1);
+failed:
+	if (sc != NULL && sc != &scs)
+		syncache_free(sc);
+	if (s != NULL)
+		free(s, M_TCPLOG);
+	*lsop = NULL;
+	return (0);
+}
+
+/*
+ * XXXNJW: TBD
+ */
+int
+syncache_expand_subflow(struct in_conninfo *inc, struct tcpopt *to, struct tcphdr *th,
+    struct socket **lsop, struct mbuf *m)
+{
+	struct syncache *sc;
+	struct syncache_head *sch;
+	struct syncache scs;
+	char *s;
+
+	struct ip *ip;
+	ip = mtod(m, struct ip *);
+
+	/*
+	 * Global TCP locks are held because we manipulate the PCB lists
+	 * and create a new socket.
+	 */
+	INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
+	KASSERT((th->th_flags & (TH_RST|TH_ACK|TH_SYN)) == TH_ACK,
+	    ("%s: can handle only ACK", __func__));
+	sc = syncache_lookup(inc, &sch);	/* returns locked sch */
+	SCH_LOCK_ASSERT(sch);
+
+	if (sc == NULL) {
+
+		/*
+		 * There is no syncache entry, so see if this ACK is
+		 * a returning syncookie.  To do this, first:
+		 *  A. See if this socket has had a syncache entry dropped in
+		 *     the past.  We don't want to accept a bogus syncookie
+		 *     if we've never received a SYN.
+		 *  B. check that the syncookie is valid.  If it is, then
+		 *     cobble up a fake syncache entry, and return.
+		 */
+		if (!V_tcp_syncookies) {
+			SCH_UNLOCK(sch);
+			if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+				log(LOG_DEBUG, "%s; %s: Spurious ACK, "
+				    "segment rejected (syncookies disabled)\n",
+				    s, __func__);
+			goto failed;
+		}
+		bzero(&scs, sizeof(scs));
+		sc = syncookie_lookup(inc, sch, &scs, th, to, *lsop);
+		SCH_UNLOCK(sch);
+		if (sc == NULL) {
+			if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+				log(LOG_DEBUG, "%s; %s: Segment failed "
+				    "SYNCOOKIE authentication, segment rejected "
+				    "(probably spoofed)\n", s, __func__);
+			goto failed;
+		}
+	} else {
+		/* Pull out the entry to unlock the bucket row. */
+		TAILQ_REMOVE(&sch->sch_bucket, sc, sc_hash);
+		sch->sch_length--;
+#ifdef TCP_OFFLOAD
+		if (ADDED_BY_TOE(sc)) {
+			struct toedev *tod = sc->sc_tod;
+
+			tod->tod_syncache_removed(tod, sc->sc_todctx);
+		}
+#endif
+		SCH_UNLOCK(sch);
+	}
+
+	/*
+	 * Segment validation:
+	 * ACK must match our initial sequence number + 1 (the SYN|ACK).
+	 */
+	if (th->th_ack != sc->sc_iss + 1) {
+		if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+			log(LOG_DEBUG, "%s; %s: ACK %u != ISS+1 %u, segment "
+			    "rejected\n", s, __func__, th->th_ack, sc->sc_iss);
+		goto failed;
+	}
+
+	/*
+	 * The SEQ must fall in the window starting at the received
+	 * initial receive sequence number + 1 (the SYN).
+	 */
+	if (SEQ_LEQ(th->th_seq, sc->sc_irs) ||
+	    SEQ_GT(th->th_seq, sc->sc_irs + sc->sc_wnd)) {
+		if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+			log(LOG_DEBUG, "%s; %s: SEQ %u != IRS+1 %u, segment "
+			    "rejected\n", s, __func__, th->th_seq, sc->sc_irs);
+		goto failed;
+	}
+
+	if (!(sc->sc_flags & SCF_TIMESTAMP) && (to->to_flags & TOF_TS)) {
+		if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+			log(LOG_DEBUG, "%s; %s: Timestamp not expected, "
+			    "segment rejected\n", s, __func__);
+		goto failed;
+	}
+	/*
+	 * If timestamps were negotiated the reflected timestamp
+	 * must be equal to what we actually sent in the SYN|ACK.
+	 */
+	if ((to->to_flags & TOF_TS) && to->to_tsecr != sc->sc_ts) {
+		if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+			log(LOG_DEBUG, "%s; %s: TSECR %u != TS %u, "
+			    "segment rejected\n",
+			    s, __func__, to->to_tsecr, sc->sc_ts);
+		goto failed;
+	}
+
+	/*
+	 *  If this is the final ACK of an MP_JOIN handshake, we need to compare
+	 *  the bytes of the hmac sent against those computed locally
+	 */
+	//to->to_mopts.snd_mac
+
+	struct sockaddr_in nam;
+	nam.sin_family = AF_INET;
+	nam.sin_port = th->th_sport;
+	nam.sin_addr = ip->ip_src;
+	nam.sin_len = sizeof(struct sockaddr_in);
+
+	/* debug output for addresses */
+	char buf[128];
+	inet_ntop(AF_INET, &ip->ip_src, buf, sizeof(buf));
+	mp_debug(MPSESSION, 4, 0, "%s: ip header from %s port %d to ",
+	    __func__, buf, ntohs(th->th_sport));
+	inet_ntop(AF_INET, &ip->ip_dst, buf, sizeof(buf));
+	mp_debug(MPSESSION, 4, 0, "%s port %d\n", buf, ntohs(th->th_dport));
+
+	*lsop = syncache_socket_subflow(sc, *lsop, m, &nam);
+
+	if (*lsop == NULL)
+		TCPSTAT_INC(tcps_sc_aborted);
+	else
+		TCPSTAT_INC(tcps_sc_completed);
+
 	if (sc != &scs)
 		syncache_free(sc);
 	return (1);
@@ -1129,8 +1482,9 @@
 	 */
 	so = *lsop;
 	tp = sototcpcb(so);
-	cred = crhold(so->so_cred);
 
+	cred = crhold(so->so_cred);											// doesn't look like it changes the master_tp or socket
+																		// could leave as-is for now.
 #ifdef INET6
 	if ((inc->inc_flags & INC_ISIPV6) &&
 	    (inp->inp_flags & IN6P_AUTOFLOWLABEL))
@@ -1272,7 +1626,7 @@
 	sc->sc_todctx = todctx;
 #endif
 	sc->sc_irs = th->th_seq;
-	sc->sc_iss = arc4random();
+	sc->sc_iss = V_tcp_override_isn > 0 ? V_tcp_override_isn : arc4random();
 	sc->sc_flags = 0;
 	sc->sc_flowlabel = 0;
 
@@ -1337,6 +1691,46 @@
 	if (to->to_flags & TOF_SIGNATURE || ltflags & TF_SIGNATURE)
 		sc->sc_flags |= SCF_SIGNATURE;
 #endif
+	sc->mpc = 0;
+	sc->sent_capable = 0;
+	sc->is_master_subflow = 1;
+
+	/*
+	 * MP SYN packets are either the start of a new connection
+	 * (MP_CAPABLE) or the addition of a subflow to an existing
+	 * connection (MP_JOIN).
+	 */
+	if (to->to_flags & TOF_MPTCP) {
+		if(to->to_mopts.mpo_flags & MPOF_MP_CAPABLE) {
+			sc->sc_flags |= SCF_MPTCP;
+			sc->sc_mp_flags |= MPF_MP_CAPABLE;
+			sc->sc_remote_key = to->to_mopts.remote_key;
+			sc->sc_local_key = mp_generate_local_key();
+			sc->mpc = 1;
+			if (to->to_mopts.mpo_flags & MPOF_USE_CSUM)
+				sc->csum_enabled = 1;
+		} else if(to->to_mopts.mpo_flags & MPOF_JOIN_SYN) {
+			sc->sc_flags |= SCF_MPTCP;
+			sc->sc_mp_flags |= MPF_MP_JOIN;
+			sc->sc_mp_token = to->to_mopts.rcv_token;
+			sc->sc_local_rand = arc4random();
+			sc->sc_remote_rand = to->to_mopts.snd_rnd;
+			sc->sc_local_key = to->to_mopts.local_key;
+			sc->sc_remote_key = to->to_mopts.remote_key;
+
+			uint32_t mac_len = mp_get_hmac(sc->sc_hmac_remote,
+				sc->sc_local_key, sc->sc_remote_key, sc->sc_local_rand,
+				sc->sc_remote_rand);
+
+			if (mac_len == 0) {
+				panic("%s: error computing MAC on JOIN_SYN\n", __func__);
+			}
+
+			sc->is_master_subflow = 0;
+			sc->mpc = 1;
+		}
+	}
+
 	if (to->to_flags & TOF_SACKPERM)
 		sc->sc_flags |= SCF_SACK;
 	if (to->to_flags & TOF_MSS)
@@ -1358,7 +1752,6 @@
 	}
 #endif
 	SCH_UNLOCK(sch);
-
 	/*
 	 * Do a standard 3-way handshake.
 	 */
@@ -1487,11 +1880,11 @@
 	th->th_win = htons(sc->sc_wnd);
 	th->th_urp = 0;
 
+
 	if (sc->sc_flags & SCF_ECN) {
 		th->th_flags |= TH_ECE;
 		TCPSTAT_INC(tcps_ecn_shs);
 	}
-
 	/* Tack on the TCP options. */
 	if ((sc->sc_flags & SCF_NOOPT) == 0) {
 		to.to_flags = 0;
@@ -1508,14 +1901,60 @@
 			to.to_tsecr = sc->sc_tsreflect;
 			to.to_flags |= TOF_TS;
 		}
+		if(sc->sc_flags & SCF_MPTCP) {
+			to.to_mopts.mpo_flags = 0;
+			/* Got a SYN with MP_CAPABLE, so send MP_CAPABLE back */
+			if(sc->sc_mp_flags & MPF_MP_CAPABLE) {
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |=
+						MPOF_CAPABLE_SYN;
+				to.to_mopts.local_key = sc->sc_local_key;
+
+				if (sc->csum_enabled)
+					to.to_mopts.mpo_flags |= MPOF_USE_CSUM;
+			}
+			/* Got a valid MP_JOIN, send MP_JOIN SYN/ACK back */
+			if(sc->sc_mp_flags & MPF_MP_JOIN) {
+				// include addressID?
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |=
+						MPOF_JOIN_SYN;
+				to.to_mopts.to_mpoptlen =
+						MPTCP_SUBLEN_MP_JOIN_SYNACK;
+				to.to_mopts.snd_rnd = sc->sc_local_rand;
+
+				uint8_t digest[20];
+				uint32_t mac_len = mp_get_hmac(digest, sc->sc_local_key,
+				    sc->sc_remote_key, sc->sc_local_rand, sc->sc_remote_rand);
+
+				if (mac_len == 0) {
+					printf("%s: error computing MAC-A\n", __func__);
+					return (ECONNREFUSED); // XXXNJW not really a connrefused...
+				}
+
+				bcopy(digest, sc->sc_hmac_local,
+					sizeof(uint64_t));
+
+				/* We copy the leftmost 64-bits of the HMAC into the option */
+				bcopy(sc->sc_hmac_local, &to.to_mopts.truncated_MAC,
+				    sizeof(uint64_t));
+			}
+		}
 		if (sc->sc_flags & SCF_SACK)
 			to.to_flags |= TOF_SACKPERM;
 #ifdef TCP_SIGNATURE
 		if (sc->sc_flags & SCF_SIGNATURE)
 			to.to_flags |= TOF_SIGNATURE;
 #endif
+		uint64_t mpof_flags = to.to_mopts.mpo_flags;
 		optlen = tcp_addoptions(&to, (u_char *)(th + 1));
 
+		/* If mp_capable was set and is now unset, then it has
+		 * been added as an option on the outgoing SYN/ACK */
+		if ((mpof_flags & MPOF_CAPABLE_SYN) &&
+		    (!to.to_mopts.mpo_flags & MPOF_CAPABLE_SYN))
+			sc->sent_capable = 1;
+
 		/* Adjust headers by option size. */
 		th->th_off = (sizeof(struct tcphdr) + optlen) >> 2;
 		m->m_len += optlen;
@@ -2025,3 +2464,29 @@
 	*pcbs_exported = count;
 	return error;
 }
+
+/* Find inp matching addresses and return locked */
+static inline struct inpcb*
+inp_lookup(struct in_addr *faddr, struct in_addr *laddr, uint16_t fport,
+    uint16_t lport) {
+	struct inpcb *inp = NULL;
+	struct tcpcb *tp = NULL;
+
+	INP_INFO_LOCK_ASSERT(&V_tcbinfo);
+	LIST_FOREACH(inp, &V_tcb, inp_list) {
+		INP_WLOCK(inp);
+		/* Important to skip tcptw structs. */
+		if (!(inp->inp_flags & INP_TIMEWAIT) &&
+			(tp = intotcpcb(inp)) != NULL) {
+				if (inp->inp_faddr.s_addr == faddr->s_addr &&
+					inp->inp_laddr.s_addr == laddr->s_addr &&
+					inp->inp_fport == fport &&
+					inp->inp_lport == lport) {
+					break;
+				}
+		}
+		INP_WUNLOCK(inp);
+	}
+
+	return(inp);
+}
diff -r 1e55e1aa8b7f sys/netinet/tcp_syncache.h
--- a/sys/netinet/tcp_syncache.h	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_syncache.h	Fri Jul 11 13:32:06 2014 +1000
@@ -41,6 +41,8 @@
 void	 syncache_unreach(struct in_conninfo *, struct tcphdr *);
 int	 syncache_expand(struct in_conninfo *, struct tcpopt *,
 	     struct tcphdr *, struct socket **, struct mbuf *);
+int	 syncache_expand_subflow(struct in_conninfo *, struct tcpopt *,
+	     struct tcphdr *, struct socket **, struct mbuf *);
 void	 syncache_add(struct in_conninfo *, struct tcpopt *,
 	     struct tcphdr *, struct inpcb *, struct socket **, struct mbuf *,
 	     void *, void *);
@@ -77,6 +79,26 @@
 
 	void		*sc_pspare;		/* TCP_SIGNATURE */
 	u_int32_t	sc_spare[2];		/* UTO */
+
+	/* MULTIPATH */
+	uint64_t	sc_ds_iss;	/* initial data sequence num */
+	uint64_t	sc_ds_irs;
+	u_int64_t	sc_remote_key;
+	u_int64_t	sc_local_key;
+	uint32_t 	sc_local_rand;	/* random number for join MAC */
+	uint32_t 	sc_remote_rand;	/* random number for join MAC */
+	uint32_t	sc_mp_token;	/* token for the multipath session */
+
+	uint8_t sc_hmac_local[20];	/* MP_JOIN handshakes use HMACs to ensure */
+	uint8_t sc_hmac_remote[20];	/* that a subflow belongs to connection */
+	char* 	sc_sentmac_ptr;		/* points to HMAC sent in mp_join ACK*/
+
+	uint8_t mpc:1,			/* other end supports mptcp */
+			sent_capable:1,	/* sent mp_cable */
+			csum_enabled:1,
+			is_master_subflow:1;
+	uint8_t		sc_mp_flags;	/* flags for mp subtype */
+	struct	mpcb *t_mpcb;		/* back pointer to multipath cb */
 };
 
 /*
@@ -88,9 +110,19 @@
 						/* MSS is implicit */
 #define SCF_UNREACH	0x10			/* icmp unreachable received */
 #define SCF_SIGNATURE	0x20			/* send MD5 digests */
+#define	SCF_MPTCP	0x40			/* MPTCP capable */
 #define SCF_SACK	0x80			/* send SACK option */
 #define SCF_ECN		0x100			/* send ECN setup packet */
 
+#define	SYNCOOKIE_SECRET_SIZE	16
+#define	SYNCOOKIE_LIFETIME	15		/* seconds */
+
+/*
+ * Flags for sc_mp_flags
+ */
+#define MPF_MP_CAPABLE	0x01
+#define MPF_MP_JOIN		0x02
+
 struct syncache_head {
 	struct mtx	sch_mtx;
 	TAILQ_HEAD(sch_head, syncache)	sch_bucket;
@@ -100,9 +132,6 @@
 	struct tcp_syncache *sch_sc;
 };
 
-#define	SYNCOOKIE_SECRET_SIZE	16
-#define	SYNCOOKIE_LIFETIME	15		/* seconds */
-
 struct syncookie_secret {
 	volatile u_int oddeven;
 	uint8_t key[2][SYNCOOKIE_SECRET_SIZE];
diff -r 1e55e1aa8b7f sys/netinet/tcp_timer.c
--- a/sys/netinet/tcp_timer.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_timer.c	Fri Jul 11 13:32:06 2014 +1000
@@ -47,6 +47,7 @@
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
 #include <sys/systm.h>
+#include <sys/taskqueue.h>
 
 #include <net/if.h>
 #include <net/route.h>
@@ -64,6 +65,7 @@
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
 #include <netinet/tcpip.h>
+#include <netinet/mptcp_var.h>
 #ifdef TCPDEBUG
 #include <netinet/tcp_debug.h>
 #endif
@@ -490,6 +492,7 @@
 
 	ostate = tp->t_state;
 #endif
+
 	INP_INFO_RLOCK(&V_tcbinfo);
 	inp = tp->t_inpcb;
 	/*
@@ -525,6 +528,9 @@
 	 * Retransmission timer went off.  Message has not
 	 * been acked within retransmit interval.  Back off
 	 * to a longer retransmit interval and retransmit one segment.
+	 *
+	 * XXXNJW: Do not want to drop the whole connection if there are other
+	 * active subflows. The modifications to do this are temporary.
 	 */
 	if (++tp->t_rxtshift > TCP_MAXRXTSHIFT) {
 		tp->t_rxtshift = TCP_MAXRXTSHIFT;
@@ -551,8 +557,10 @@
 		headlocked = 1;
 		goto out;
 	}
+
 	INP_INFO_RUNLOCK(&V_tcbinfo);
 	headlocked = 0;
+
 	if (tp->t_state == TCPS_SYN_SENT) {
 		/*
 		 * If the SYN was retransmitted, indicate CWND to be
@@ -615,6 +623,17 @@
 		tp->t_rttvar += (tp->t_srtt >> TCP_RTT_SHIFT);
 		tp->t_srtt = 0;
 	}
+
+	/*
+	 * After two RTOs firing, try to re-transmit un-acked data-level segments.
+	 * XXXNJW: want to set up a generic hook so that the rexmit can be handled
+	 * in a more dynamic way.
+	 */
+	// triggered only once. all un-acked segments are enqueued at this time.
+	if (tp->t_state == TCPS_ESTABLISHED && tp->mp_active &&
+	    tp->t_rxtshift == TCP_MAXRXTSHIFT / 6)
+		mp_queue_data_rexmit_unlocked(tp);
+
 	tp->snd_nxt = tp->snd_una;
 	tp->snd_recover = tp->snd_max;
 	/*
diff -r 1e55e1aa8b7f sys/netinet/tcp_timewait.c
--- a/sys/netinet/tcp_timewait.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_timewait.c	Fri Jul 11 13:32:06 2014 +1000
@@ -39,6 +39,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/callout.h>
+#include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/sysctl.h>
 #include <sys/malloc.h>
@@ -77,6 +78,7 @@
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp_var.h>
 #ifdef INET6
 #include <netinet6/tcp6_var.h>
 #endif
@@ -319,6 +321,15 @@
  */
 	acknow = tp->t_flags & TF_ACKNOW;
 
+	/* XXXNJW a very rough test to prevent socket being released while other
+	 * subflows can still use it. To be removed once a proper shutdown
+	 * implementation is sorted out. clearing the flag that indicates we
+	 * hole the only reference. should ideally be cleared when new subflows
+	 * are added, and set when only one subflow remains. */
+	if (tp->t_mpcb)
+		if (tp->t_mpcb->subflow_cnt != 1)
+			inp->inp_flags &= ~INP_SOCKREF;
+
 	/*
 	 * First, discard tcpcb state, which includes stopping its timers and
 	 * freeing it.  tcp_discardcb() used to also release the inpcb, but
@@ -329,11 +340,14 @@
 	 */
 	tcp_discardcb(tp);
 	so = inp->inp_socket;
-	soisdisconnected(so);
+//	if((so->so_state & SS_ISDISCONNECTED) == 0)
+//		soisdisconnected(so);
 	tw->tw_cred = crhold(so->so_cred);
+
 	SOCK_LOCK(so);
 	tw->tw_so_options = so->so_options;
 	SOCK_UNLOCK(so);
+
 	if (acknow)
 		tcp_twrespond(tw, TH_ACK);
 	inp->inp_ppcb = tw;
@@ -344,17 +358,20 @@
 	 * If the inpcb owns the sole reference to the socket, then we can
 	 * detach and free the socket as it is not needed in time wait.
 	 */
-	if (inp->inp_flags & INP_SOCKREF) {
+	if (inp->inp_flags & INP_SOCKREF &&
+	    (so->so_state & SS_ISDISCONNECTED)) {
 		KASSERT(so->so_state & SS_PROTOREF,
-		    ("tcp_twstart: !SS_PROTOREF"));
+			("tcp_twstart: !SS_PROTOREF"));
 		inp->inp_flags &= ~INP_SOCKREF;
 		INP_WUNLOCK(inp);
 		ACCEPT_LOCK();
 		SOCK_LOCK(so);
 		so->so_state &= ~SS_PROTOREF;
+		printf("%s: calling sofree with discarded tp %p\n", __func__, tp);
 		sofree(so);
 	} else
 		INP_WUNLOCK(inp);
+
 }
 
 #if 0
